#
# Md5 brute forcer for CELL architecture
#
# Simon Marechal
# Raboin Romain <romain.raboin at gmail.com> (2008)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

	
.data
.equ LR_OFFSET, 16
.equ MAIN_FRAME_SIZE, 32
.equ MFC_GET_CMD, 0x40
.equ MFC_PUT_CMD, 0x20

.equ DATA_LEN, (64)

.align 4
data: .octa 0

ptr_struct:
remote_buffer: .octa 0
remote_hashes: .octa 0
remote_bf: .octa 0
targeta: .octa 0
targetb: .octa 0
targetc: .octa 0
targetd: .octa 0

remote_pwd: .octa 0
remote_nbpwd: .double 0
.equ PTR_STRUCT_SIZE, (16*7)
.equ PARA, 4
.equ NB_PWD, (4*PARA)
.equ BUFFER_SIZE, (64*NB_PWD)
.equ CHARSET, 62
.equ BF_NB, (CHARSET*CHARSET)
.equ HASHES_LEN, (16*NB_PWD)

begin: .ascii "got ptr = 0x%llx\n\0"
hexa: .ascii "0x%.8lx \0"
cr: .ascii "\n\0"

.section .bss #Uninitialized Data Section
.align 4
.lcomm md5_buffer, (BUFFER_SIZE)
.lcomm bf_buffer, (BF_NB*4)

#define PRINT_HEXA(x) ila $3, hexa; ila $4, (x); brsl $lr, printf;
### #define PRINT_HEXAR(x) ila $3, hexa; lr $4, x; brsl $lr, printf;
#define PRINT_HEXAR(x) rotqbyi $4, x, 8; ila $3, hexa; brsl $lr, printf;
#define PRINT_PTR(x) ila $3, begin; ila $4, (x); brsl $lr, printf;
#define PRINT_PTRR(x) ila $3, begin; lr $4, x; brsl $lr, printf;
#define CR	ila $3, cr; brsl $lr, printf;

.text
.global main
.type main,@function
main:

#PROLOGUE#
        stqd $lr, LR_OFFSET($sp)
        stqd $sp, -MAIN_FRAME_SIZE($sp)
        ai $sp, $sp, -MAIN_FRAME_SIZE

	stqr $4, data

##COPY IN PTR INFORMATION##
ila $3, ptr_struct
lqr $4, data
il $5, PTR_STRUCT_SIZE
il $6, 0
il $7, MFC_GET_CMD
brsl $lr, perform_dma
il $3, 0
brsl $lr, wait_for_dma_completion

##COPY IN BF BUFFER##
ila $3, bf_buffer
lqr $4, remote_bf
il $5, BF_NB*4
il $6, 0
il $7, MFC_GET_CMD
brsl $lr, perform_dma
il $3, 0
brsl $lr, wait_for_dma_completion

	lqr $12, remote_hashes
	#PRINT_PTRR($12)

#define AA      $127
#define BB      $126
#define CC      $125
#define DD      $124

#define CST    $123
#define A0	$122
#define A1	$121
#define A2	$120
#define A3	$119
#define B0	$118
#define B1	$117
#define B2	$116
#define B3	$115
#define C0	$114
#define C1	$113
#define C2	$112
#define C3	$111
#define D0	$110
#define D1	$109
#define D2	$108
#define D3	$107
#define TMP1_0	$106
#define TMP1_1	$105
#define TMP1_2	$104
#define TMP1_3	$103
#define TMP2_0	$102
#define TMP2_1	$101
#define TMP2_2	$100
#define TMP2_3	$99
#define TMP3_0	$98
#define TMP3_1	$97
#define TMP3_2	$96
#define TMP3_3	$95

#define CURHASH $94
#define INC	$93
#define INDEX	$92
#define TA	$91
#define TB	$90
#define TC	$89
#define TD	$88
#define FOUND	$87

#define TEMPOA0	$86
#define TEMPOA1	$85
#define TEMPOA2	$84
#define TEMPOA3	$83
#define TEMPOB0	$82
#define TEMPOB1	$81
#define TEMPOB2	$80
#define TEMPOB3	$79
#define TEMPOC0	$78
#define TEMPOC1	$77
#define TEMPOC2	$76
#define TEMPOC3	$75
#define TEMPOD0	$74
#define TEMPOD1	$73
#define TEMPOD2	$72
#define TEMPOD3	$71
#define TEMPOG0	$70
#define TEMPOG1	$69
#define TEMPOG2	$68
#define TEMPOG3	$67

#define STEPA(ta0,tb0,tc0,td0,ta1,tb1,tc1,td1,ta2,tb2,tc2,td2,ta3,tb3,tc3,td3,in,rot) \
	lqr TMP2_0, (md5_buffer+in*16*PARA+16*0);\
	lqr TMP2_1, (md5_buffer+in*16*PARA+16*1);\
	lqr TMP2_2, (md5_buffer+in*16*PARA+16*2);\
	lqr TMP2_3, (md5_buffer+in*16*PARA+16*3);\
	xor TMP1_0, tc0, td0;\
	xor TMP1_1, tc1, td1;\
	xor TMP1_2, tc2, td2;\
	xor TMP1_3, tc3, td3;\
	a TMP2_0, TMP2_0, CST;\
	a TMP2_1, TMP2_1, CST;\
	a TMP2_2, TMP2_2, CST;\
	a TMP2_3, TMP2_3, CST;\
	and TMP1_0, TMP1_0, tb0;\
	and TMP1_1, TMP1_1, tb1;\
	and TMP1_2, TMP1_2, tb2;\
	and TMP1_3, TMP1_3, tb3;\
	a TMP2_0, TMP2_0, ta0;\
	a TMP2_1, TMP2_1, ta1;\
	a TMP2_2, TMP2_2, ta2;\
	a TMP2_3, TMP2_3, ta3;\
	xor TMP1_0, TMP1_0, td0;\
	xor TMP1_1, TMP1_1, td1;\
	xor TMP1_2, TMP1_2, td2;\
	xor TMP1_3, TMP1_3, td3;\
	a TMP1_0, TMP1_0, TMP2_0;\
	a TMP1_1, TMP1_1, TMP2_1;\
	a TMP1_2, TMP1_2, TMP2_2;\
	a TMP1_3, TMP1_3, TMP2_3;\
	roti ta0, TMP1_0, rot;\
	roti ta1, TMP1_1, rot;\
	roti ta2, TMP1_2, rot;\
	roti ta3, TMP1_3, rot;\
a ta0, ta0, tb0; \
a ta1, ta1, tb1; \
a ta2, ta2, tb2; \
a ta3, ta3, tb3; \


#define STEPB(ta0,tb0,tc0,td0,ta1,tb1,tc1,td1,ta2,tb2,tc2,td2,ta3,tb3,tc3,td3,in,rot) \
	lqr TMP2_0, (md5_buffer+in*16*PARA+16*0);\
	lqr TMP2_1, (md5_buffer+in*16*PARA+16*1);\
	lqr TMP2_2, (md5_buffer+in*16*PARA+16*2);\
	lqr TMP2_3, (md5_buffer+in*16*PARA+16*3);\
	xor TMP1_0, tb0, tc0;\
	xor TMP1_1, tb1, tc1;\
	xor TMP1_2, tb2, tc2;\
	xor TMP1_3, tb3, tc3;\
	a TMP2_0, TMP2_0, CST; \
	a TMP2_1, TMP2_1, CST; \
	a TMP2_2, TMP2_2, CST; \
	a TMP2_3, TMP2_3, CST; \
	and TMP1_0, TMP1_0, td0;\
	and TMP1_1, TMP1_1, td1;\
	and TMP1_2, TMP1_2, td2;\
	and TMP1_3, TMP1_3, td3;\
	xor TMP1_0, TMP1_0, tc0;\
	xor TMP1_1, TMP1_1, tc1;\
	xor TMP1_2, TMP1_2, tc2;\
	xor TMP1_3, TMP1_3, tc3;\
	a TMP2_0, TMP2_0, ta0;\
	a TMP2_1, TMP2_1, ta1;\
	a TMP2_2, TMP2_2, ta2;\
	a TMP2_3, TMP2_3, ta3;\
	a TMP1_0, TMP1_0, TMP2_0;\
	a TMP1_1, TMP1_1, TMP2_1;\
	a TMP1_2, TMP1_2, TMP2_2;\
	a TMP1_3, TMP1_3, TMP2_3;\
	roti ta0, TMP1_0, rot;\
	roti ta1, TMP1_1, rot;\
	roti ta2, TMP1_2, rot;\
	roti ta3, TMP1_3, rot;\
a ta0, ta0, tb0; \
a ta1, ta1, tb1; \
a ta2, ta2, tb2; \
a ta3, ta3, tb3; \


#define STEPC(ta0,tb0,tc0,td0,ta1,tb1,tc1,td1,ta2,tb2,tc2,td2,ta3,tb3,tc3,td3,in,rot) \
	lqr TMP2_0, (md5_buffer+in*16*PARA+16*0);\
	lqr TMP2_1, (md5_buffer+in*16*PARA+16*1);\
	lqr TMP2_2, (md5_buffer+in*16*PARA+16*2);\
	lqr TMP2_3, (md5_buffer+in*16*PARA+16*3);\
	xor TMP1_0, tb0, tc0;\
	xor TMP1_1, tb1, tc1;\
	xor TMP1_2, tb2, tc2;\
	xor TMP1_3, tb3, tc3;\
	a TMP2_0, TMP2_0, CST;\
	a TMP2_1, TMP2_1, CST;\
	a TMP2_2, TMP2_2, CST;\
	a TMP2_3, TMP2_3, CST;\
	xor TMP1_0, TMP1_0, td0;\
	xor TMP1_1, TMP1_1, td1;\
	xor TMP1_2, TMP1_2, td2;\
	xor TMP1_3, TMP1_3, td3;\
	a TMP2_0, TMP2_0, ta0;\
	a TMP2_1, TMP2_1, ta1;\
	a TMP2_2, TMP2_2, ta2;\
	a TMP2_3, TMP2_3, ta3;\
	a TMP1_0, TMP1_0, TMP2_0;\
	a TMP1_1, TMP1_1, TMP2_1;\
	a TMP1_2, TMP1_2, TMP2_2;\
	a TMP1_3, TMP1_3, TMP2_3;\
	roti ta0, TMP1_0, rot;\
	roti ta1, TMP1_1, rot;\
	roti ta2, TMP1_2, rot;\
	roti ta3, TMP1_3, rot;\
a ta0, ta0, tb0; \
a ta1, ta1, tb1; \
a ta2, ta2, tb2; \
a ta3, ta3, tb3; \


#define STEPD(ta0,tb0,tc0,td0,ta1,tb1,tc1,td1,ta2,tb2,tc2,td2,ta3,tb3,tc3,td3,in,rot) \
	lqr TMP2_0, (md5_buffer+in*16*PARA+16*0);\
	lqr TMP2_1, (md5_buffer+in*16*PARA+16*1);\
	lqr TMP2_2, (md5_buffer+in*16*PARA+16*2);\
	lqr TMP2_3, (md5_buffer+in*16*PARA+16*3);\
nor TMP1_0, td0, td0; \
nor TMP1_1, td1, td1; \
nor TMP1_2, td2, td2; \
nor TMP1_3, td3, td3; \
	or TMP1_0, tb0, TMP1_0;\
	or TMP1_1, tb1, TMP1_1;\
	or TMP1_2, tb2, TMP1_2;\
	or TMP1_3, tb3, TMP1_3;\
	a TMP2_0, TMP2_0, CST;\
	a TMP2_1, TMP2_1, CST;\
	a TMP2_2, TMP2_2, CST;\
	a TMP2_3, TMP2_3, CST;\
	xor TMP1_0, TMP1_0, tc0;\
	xor TMP1_1, TMP1_1, tc1;\
	xor TMP1_2, TMP1_2, tc2;\
	xor TMP1_3, TMP1_3, tc3;\
	a TMP2_0, TMP2_0, ta0;\
	a TMP2_1, TMP2_1, ta1;\
	a TMP2_2, TMP2_2, ta2;\
	a TMP2_3, TMP2_3, ta3;\
	a TMP1_0, TMP1_0, TMP2_0;\
	a TMP1_1, TMP1_1, TMP2_1;\
	a TMP1_2, TMP1_2, TMP2_2;\
	a TMP1_3, TMP1_3, TMP2_3;\
	roti ta0, TMP1_0, rot;\
	roti ta1, TMP1_1, rot;\
	roti ta2, TMP1_2, rot;\
	roti ta3, TMP1_3, rot;\
a ta0, ta0, tb0; \
a ta1, ta1, tb1; \
a ta2, ta2, tb2; \
a ta3, ta3, tb3; \

##init##
ilhu AA, 0x6745
iohl AA, 0x2301
ilhu BB, 0xefcd
iohl BB, 0xab89
ilhu CC, 0x98ba
iohl CC, 0xdcfe
ilhu DD, 0x1032
iohl DD, 0x5476

	lqr TA, targeta;
	lqr TB, targetb;
	lqr TC, targetc;
	lqr TD, targetd;

	xor FOUND, FOUND, FOUND

## on va y aller ##
	rdch TMP1_3, $SPU_RdInMbox 
main_loop:
	il INC, (BF_NB/4)
	ila INDEX, bf_buffer

##COPY IN MD4 BUFFER##
ila $3, md5_buffer
lqr $4, remote_buffer
il $5, BUFFER_SIZE
il $6, 0
il $7, MFC_GET_CMD
brsl $lr, perform_dma
il $3, 0
brsl $lr, wait_for_dma_completion

##crack##
	rdch TMP1_3, $SPU_RdInMbox 
	brnz TMP1_3, aff
crack_loop:
	lqd CURHASH, 0(INDEX)
	lr A0, AA
	lr A1, AA
	lr A2, AA
	lr A3, AA
	lr B0, BB
	lr B1, BB
	lr B2, BB
	lr B3, BB
	lr C0, CC
	lr C1, CC
	lr C2, CC
	lr C3, CC
	lr D0, DD
	lr D1, DD
	lr D2, DD
	lr D3, DD

ilhu CST, 0xD76A
iohl CST, 0xA478
	a CST, CST, CURHASH
	STEPA(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,0,7);
ilhu CST, 0xE8C7
iohl CST, 0xB756
	STEPA(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,1,12);
ilhu CST, 0x2420
iohl CST, 0x70DB
	STEPA(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,2,17);
ilhu CST, 0xC1BD
iohl CST, 0xCEEE
	STEPA(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,3,22);
ilhu CST, 0xF57C
iohl CST, 0x0FAF
	STEPA(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,4,7);
ilhu CST, 0x4787
iohl CST, 0xC62A
	STEPA(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,5,12);
ilhu CST, 0xA830
iohl CST, 0x4613
	STEPA(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,6,17);
ilhu CST, 0xFD46
iohl CST, 0x9501
	STEPA(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,7,22);
ilhu CST, 0x6980
iohl CST, 0x98D8
	STEPA(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,8,7);
ilhu CST, 0x8B44
iohl CST, 0xF7AF
	STEPA(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,9,12);
ilhu CST, 0xFFFF
iohl CST, 0x5BB1
	STEPA(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,10,17);
ilhu CST, 0x895C
iohl CST, 0xD7BE
	STEPA(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,11,22);
ilhu CST, 0x6B90
iohl CST, 0x1122
	STEPA(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,12,7);
ilhu CST, 0xFD98
iohl CST, 0x7193
	STEPA(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,13,12);
ilhu CST, 0xA679
iohl CST, 0x438E
	STEPA(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,14,17);
ilhu CST, 0x49B4
iohl CST, 0x0821
	STEPA(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,15,22);

ilhu CST, 0xF61E
iohl CST, 0x2562
	STEPB(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,1,5);
ilhu CST, 0xC040
iohl CST, 0xB340
	STEPB(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,6,9);
ilhu CST, 0x265E
iohl CST, 0x5A51
	STEPB(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,11,14);
ilhu CST, 0xE9B6
iohl CST, 0xC7AA
	a CST, CST, CURHASH
	STEPB(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,0,20);
ilhu CST, 0xD62F
iohl CST, 0x105D
	STEPB(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,5,5);
ilhu CST, 0x0244
iohl CST, 0x1453
	STEPB(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,10,9);
ilhu CST, 0xD8A1
iohl CST, 0xE681
	STEPB(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,15,14);
ilhu CST, 0xE7D3
iohl CST, 0xFBC8
	STEPB(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,4,20);
ilhu CST, 0x21E1
iohl CST, 0xCDE6
	STEPB(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,9,5);
ilhu CST, 0xC337
iohl CST, 0x07D6
	STEPB(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,14,9);
ilhu CST, 0xF4D5
iohl CST, 0x0D87
	STEPB(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,3,14);
ilhu CST, 0x455A
iohl CST, 0x14ED
	STEPB(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,8,20);
ilhu CST, 0xA9E3
iohl CST, 0xE905
	STEPB(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,13,5);
ilhu CST, 0xFCEF
iohl CST, 0xA3F8
	STEPB(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,2,9);
ilhu CST, 0x676F
iohl CST, 0x02D9
	STEPB(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,7,14);
ilhu CST, 0x8D2A
iohl CST, 0x4C8A
	STEPB(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,12,20);

ilhu CST, 0xFFFA
iohl CST, 0x3942
	STEPC(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,5,4);
ilhu CST, 0x8771
iohl CST, 0xF681
	STEPC(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,8,11);
ilhu CST, 0x6D9D
iohl CST, 0x6122
	STEPC(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,11,16);
ilhu CST, 0xFDE5
iohl CST, 0x380C
	STEPC(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,14,23);
ilhu CST, 0xA4BE
iohl CST, 0xEA44
	STEPC(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,1,4);
ilhu CST, 0x4BDE
iohl CST, 0xCFA9
	STEPC(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,4,11);
ilhu CST, 0xF6BB
iohl CST, 0x4B60
	STEPC(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,7,16);
ilhu CST, 0xBEBF
iohl CST, 0xBC70
	STEPC(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,10,23);
ilhu CST, 0x289B
iohl CST, 0x7EC6
	STEPC(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,13,4);
ilhu CST, 0xEAA1
iohl CST, 0x27FA
	a CST, CST, CURHASH
	STEPC(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,0,11);
ilhu CST, 0xD4EF
iohl CST, 0x3085
	STEPC(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,3,16);
ilhu CST, 0x0488
iohl CST, 0x1D05
	STEPC(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,6,23);
ilhu CST, 0xD9D4
iohl CST, 0xD039
	STEPC(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,9,4);
ilhu CST, 0xE6DB
iohl CST, 0x99E5
	STEPC(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,12,11);
ilhu CST, 0x1FA2
iohl CST, 0x7CF8
	STEPC(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,15,16);
ilhu CST, 0xC4AC
iohl CST, 0x5665
	STEPC(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,2,23);

ilhu CST, 0xF429
iohl CST, 0x2244
	a CST, CST, CURHASH
	STEPD(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,0,6);
ilhu CST, 0x432A
iohl CST, 0xFF97
	STEPD(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,7,10);
ilhu CST, 0xAB94
iohl CST, 0x23A7
	STEPD(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,14,15);
ilhu CST, 0xFC93
iohl CST, 0xA039
	STEPD(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,5,21);
ilhu CST, 0x655B
iohl CST, 0x59C3
	STEPD(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,12,6);
ilhu CST, 0x8F0C
iohl CST, 0xCC92
	STEPD(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,3,10);
ilhu CST, 0xFFEF
iohl CST, 0xF47D
	STEPD(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,10,15);
ilhu CST, 0x8584
iohl CST, 0x5DD1
	STEPD(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,1,21);
ilhu CST, 0x6FA8
iohl CST, 0x7E4F
	STEPD(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,8,6);
ilhu CST, 0xFE2C
iohl CST, 0xE6E0
	STEPD(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,15,10);
ilhu CST, 0xA301
iohl CST, 0x4314
	STEPD(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,6,15);
ilhu CST, 0x4E08
iohl CST, 0x11A1
	STEPD(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,13,21);
ilhu CST, 0xF753
iohl CST, 0x7E82
	STEPD(A0,B0,C0,D0,A1,B1,C1,D1,A2,B2,C2,D2,A3,B3,C3,D3,4,6);
ilhu CST, 0xBD3A
iohl CST, 0xF235
	STEPD(D0,A0,B0,C0,D1,A1,B1,C1,D2,A2,B2,C2,D3,A3,B3,C3,11,10);
ilhu CST, 0x2AD7
iohl CST, 0xD2BB
	STEPD(C0,D0,A0,B0,C1,D1,A1,B1,C2,D2,A2,B2,C3,D3,A3,B3,2,15);
ilhu CST, 0xEB86
iohl CST, 0xD391
	STEPD(B0,C0,D0,A0,B1,C1,D1,A1,B2,C2,D2,A2,B3,C3,D3,A3,9,21);

	a A0, A0, AA
	a A1, A1, AA
	a A2, A2, AA
	a A3, A3, AA
	a B0, B0, BB
	a B1, B1, BB
	a B2, B2, BB
	a B3, B3, BB
	a C0, C0, CC
	a C1, C1, CC
	a C2, C2, CC
	a C3, C3, CC
	a D0, D0, DD
	a D1, D1, DD
	a D2, D2, DD
	a D3, D3, DD


	ceq TEMPOA0, A0, TA
	ceq TEMPOA1, A1, TA
	ceq TEMPOA2, A2, TA
	ceq TEMPOA3, A3, TA
	ceq TEMPOB0, B0, TB
	ceq TEMPOB1, B1, TB
	ceq TEMPOB2, B2, TB
	ceq TEMPOB3, B3, TB
	ceq TEMPOC0, C0, TC
	ceq TEMPOC1, C1, TC
	ceq TEMPOC2, C2, TC
	ceq TEMPOC3, C3, TC
	ceq TEMPOD0, D0, TD
	ceq TEMPOD1, D1, TD
	ceq TEMPOD2, D2, TD
	ceq TEMPOD3, D3, TD
	
/* and */
	and TEMPOG0, TEMPOA0, TEMPOB0
	and TEMPOG1, TEMPOA1, TEMPOB1
	and TEMPOG2, TEMPOA2, TEMPOB2
	and TEMPOG3, TEMPOA3, TEMPOB3
	and TEMPOG0, TEMPOG0, TEMPOC0
	and TEMPOG1, TEMPOG1, TEMPOC1
	and TEMPOG2, TEMPOG2, TEMPOC2
	and TEMPOG3, TEMPOG3, TEMPOC3
	and TEMPOG0, TEMPOG0, TEMPOD0
	and TEMPOG1, TEMPOG1, TEMPOD1
	and TEMPOG2, TEMPOG2, TEMPOD2
	and TEMPOG3, TEMPOG3, TEMPOD3
/* /and */
	ai INC, INC, -1
	ai INDEX, INDEX, 16

	or FOUND, FOUND, TEMPOG0
	or FOUND, FOUND, TEMPOG1
	or FOUND, FOUND, TEMPOG2
	or FOUND, FOUND, TEMPOG3

	brnz INC, crack_loop

## store result ##
store:
	stqr FOUND, md5_buffer

##COPY BACK##
ila $3, md5_buffer
lqr $4, remote_hashes
il $5, 16
il $6, 0
il $7, MFC_PUT_CMD
brsl $lr, perform_dma
il $3, 0
brsl $lr, wait_for_dma_completion

	xor FOUND, FOUND, FOUND 
	wrch $SPU_WrOutMbox, A0
	br main_loop

aff:

	br crack_loop
